APMD(8)

NAME
apmd - Advanced Power Management daemon

SYNOPSIS
apmd [-AadHLs] [-f devname] [-S sockname] [-t seconds] [-w percent] [-Z percent] [-z percent]

DESCRIPTION
apmd monitors the advanced power management device, apm(4), acting on signaled events and upon user requests as sent by the apm(8) program.

On OpenBSD, power management is handled by the kernel, and the default policy can be set using the hw.perfpolicy sysctl(2). If apmd is not running, apm(8) is still able to query the apm(4) driver for a limited amount of information, but apmd provides more advanced functionality, such as the ability to switch performance modes.

For suspend and standby request events delivered by the BIOS, or via apm(8), apmd runs the appropriate configuration program (if one exists), syncs the buffer cache to disk and initiates the requested state. When resuming after suspend or standby, apmd runs the appropriate configuration program (if one exists).

When the power status changes (external power is connected or disconnected), apmd fetches the current status and reports it via syslog(3) with logging facility LOG_DAEMON.

apmd can change the system performance policy at startup when called with the -A, -H or -L options, and during runtime when requested by apm(8). The default performance policy is "high" when connected to line current, and "auto" when running on battery.

The options are as follows:

-A  Start apmd in automatic performance adjustment mode.

-a  BIOS-initiated suspend or standby requests are ignored if the system is connected to line current and not running from batteries (user requests are still honored).

-d  apmd enters debug mode, staying in the foreground. Logging output is printed to stderr.

-f devname
    Specify an alternate device file name, devname.

-H  Start apmd in manual performance adjustment mode, initialising hw.setperf to 100.

-L  Start apmd in manual performance adjustment mode, initialising hw.setperf to 0.

-S sockname
    Specify an alternate socket name, sockname. The socket is protected to mode 0660, UID 0, GID 0; this protects access to suspend requests to authorized users only.

-s  Current battery statistics are reported via syslog(3) and apmd exits without monitoring the APM status.

-t seconds
    apmd periodically polls the APM driver for the current power state. If the battery charge level changes substantially or the external power status changes, the new status is logged. The polling rate defaults to once per 10 minutes, but may be specified using the -t command-line flag.

-w percent
    Log warning and enable “warnlow” actions if no AC is connected and the estimated battery life is equal or below percent.

-Z percent
    Automatically hibernate the system if no AC is connected and the estimated battery life is equal or below percent.

-z percent
    Automatically suspend the system if no AC is connected and the estimated battery life is equal or below percent.

    If both -Z and -z are specified, the last one will supersede the other. After a resume, the effect of those options is inhibited for 60 seconds.

When a client requests a suspend or stand-by state, apmd does not wait for positive confirmation that the requested state has been entered before replying to the client; to do so would mean the client does not get a reply until the system resumes from its sleep state. Rather, apmd replies with the intended state to the client and then places the system in the requested state after running the configuration script and flushing the buffer cache.

Actions can be configured for the following transitions: hibernate, powerdown, powerup, resume, standby, suspend, and warnlow. The warnlow action is run if -w is used. The suspend, hibernate and standby actions are run prior to apmd performing any other actions (such as disk syncs) and entering the new state. The resume program is run after resuming from a stand-by or suspended state. The powerup and powerdown programs are run after the power status (AC connected or not) changes, as well as after a resume (if the power status changed in the mean time).

FILES
/dev/apmctl
    Default device used to control apm(4).

/etc/apm/hibernate
/etc/apm/powerdown
/etc/apm/powerup
/etc/apm/resume
/etc/apm/standby
/etc/apm/suspend
/etc/apm/warnlow
    Action hook files which, if present, must be executable. Each file must be an executable binary or shell script. A single program or script can be used to control all transitions by examining the name by which it was called.

/etc/random.seed
    Random seed file read by the bootloader; updated on “hibernate”, “standby” and “suspend”.

/var/run/apmdev
    Default UNIX-domain socket used for communication with apm(8).

EXAMPLES

/etc/apm/suspend
        # X11 screen lock
        pkill -USR1 xidle

/etc/apm/warnlow
        # low battery notifications
        aucat -i /etc/apm/tired.wav

SEE ALSO
syslog(3), apm(4), apm(8), sysctl(8)

Advanced Power Management (APM) BIOS Interface Specification (revision 1.2), Intel Corporation and Microsoft Corporation.

HISTORY
The apmd command first appeared in NetBSD 1.3. OpenBSD support was added in OpenBSD 1.2.

CAVEATS
apmd does not support specifying an alternate performance policy to be used when the system is running on battery. See the hw.perfpolicy setting documented in sysctl(2).